package ver4;

public class Registration {
	// Hard code weights. Not a flexible solution.
	private final static double HW_PERCENT = 0.2;
	private final static double TEST_PERCENT = 0.6;
	private final static double FINAL_EXAM_PERCENT = 0.2;

	private Student student;
	private Course course;
	private double hwAvg;
	private double testAvg;
	private double finalExam;
	private double finalAverage;
	
	protected Registration() {}
	
	public Registration(Student student, Course course) {
		this.student = student;
		this.course = course;
		this.hwAvg = 0.0;
		this.testAvg = 0.0;
		this.finalExam = 0.0;
		this.finalAverage = 0.0;
		
	}
	
	public double getHwAvg() {
		return hwAvg;
	}

	public double getTestAvg() {
		return testAvg;
	}

	public double getFinalExam() {
		return finalExam;
	}

	public double getFinalAverage() {
		return finalAverage;
	}
	
	public String getDepartment() {
		return course.getDepartment();
	}

	public String getCourseName() {
		return course.getName();
	}

	public Student getStudent() {
		return student;
	}

	public Course getCourse() {
		return course;
	}

	
	public boolean equals(Object o) {
		if(o instanceof Registration r) {
			return this.student.equals(r.student) &&
					this.course.equals(r.course);
		}
		return false;
	}

	
	void setGrades(double hwAvg, double testAvg, double finalExam) {
		this.hwAvg = hwAvg;
		this.testAvg = testAvg;
		this.finalExam = finalExam;
		this.finalAverage = HW_PERCENT * hwAvg + 
				TEST_PERCENT * testAvg +
				FINAL_EXAM_PERCENT * finalExam;
	}

	@Override
	public String toString() {
		return "Registration [hwAvg=" + hwAvg + ", testAvg=" + testAvg + 
				", finalExam=" + finalExam + 
				", finalAverag=" + finalAverage + 
				"]";
	}
	
}
