package ver4.mock;

import static org.junit.jupiter.api.Assertions.*;
import java.time.LocalDate;
import org.junit.jupiter.api.Test;

class StudentTest {

	@Test
	void testAddRegistration() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student studentMock = new StudentMock("Dave", "Gibson", bDate, "222348834");
		Course courseMock = new CourseMock()
		Registration r = new RegistrationMock("CS 3340");
		student.addRegistration(r);
		r = new RegistrationMock("CS 4321");
		student.addRegistration(r);
		assertEquals(2, student.getNumRegistrations());
	}

	@Test
	void testEqualsObject() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student student1 = new Student("Dave", "Gibson", bDate, "222348834");
		bDate = LocalDate.parse("2003-11-30");
		Student student2 = new Student("Art", "Taylor", bDate, "222348834");
		assertTrue(student1.equals(student2));
	}

	@Test
	void testIsRegisteredForTrue() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student student = new Student("Dave", "Gibson", bDate, "222348834");
		Registration r = new RegistrationMock("CS 3340");
		student.addRegistration(r);
		r = new RegistrationMock("CS 4321");
		student.addRegistration(r);
		Course c = new CourseMock("CS 4321");
		assertTrue(student.isRegisteredFor(c));
	}

	@Test
	void testIsRegisteredForFalse() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student student = new Student("Dave", "Gibson", bDate, "222348834");
		Registration r = new RegistrationMock("CS 3340");
		student.addRegistration(r);
		r = new RegistrationMock("CS 4321");
		student.addRegistration(r);
		Course c = new CourseMock("CS 1302");
		assertFalse(student.isRegisteredFor(c));
	}

	@Test
	void testGetCourseSuccess() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student student = new Student("Dave", "Gibson", bDate, "222348834");
		Registration r = new RegistrationMock("CS 3340");
		student.addRegistration(r);
		r = new RegistrationMock("CS 4321");
		student.addRegistration(r);
		Course c = student.getCourse("CS 4321");
		assertEquals("CS 4321", c.getName());
	}

	@Test
	void testGetCourseFail() {
		LocalDate bDate = LocalDate.parse("1999-04-26");
		Student student = new Student("Dave", "Gibson", bDate, "222348834");
		Registration r = new RegistrationMock("CS 3340");
		student.addRegistration(r);
		r = new RegistrationMock("CS 4321");
		student.addRegistration(r);
		Course c = student.getCourse("CS 1234");
		assertNull(c);
	}

}
